<img src="https://github.com/qojulia/QuantumOptics.jl-website/blob/master/src/images/logo.png" alt="QuantumOptics.jl" width="400">

#

[![Chat on Gitter][gitter-img]][gitter-url] [![Travis build status][travis-img]][travis-url] [![Windows build status][appveyor-img]][appveyor-url] [![Stable documentation][docs-img]][docs-url]

**QuantumOptics.jl** is a numerical framework written in [Julia] that makes it easy to simulate various kinds of quantum systems. It is inspired by the [Quantum Optics Toolbox] for MATLAB and the Python framework [QuTiP].

More information, documentation and examples can be found on our website http://qojulia.org.


### Development status

**Latest release:**
  * [![Status of latest release on julia 0.6][pkg-0.6-img]][pkg-0.6-url]
  * Test coverage:
        [![Test coverage status on coveralls][coveralls-img]][coveralls-url]
        [![Test coverage status on codecov][codecov-img]][codecov-url]


### Project structure

The content associated with **QuantumOptics.jl** is distributed over several repositories under the [qojulia] organization on github:

* The main code: https://github.com/qojulia/QuantumOptics.jl
* Documentation: https://github.com/qojulia/QuantumOptics.jl-documentation
* Examples: https://github.com/qojulia/QuantumOptics.jl-examples
* Benchmarks: https://github.com/qojulia/QuantumOptics.jl-benchmarks
* Website: https://github.com/qojulia/QuantumOptics.jl-website


### Questions & Contributions

Contributions of any kind are always welcome! Be it as questions, ideas for new features, bug reports or, our favorite case, sending pull requests.

### Citing

If you like **QuantumOptics.jl**, we would appreciate it if you starred the repository in order to help us increase its visibility. Furthermore, if you find the framework useful in your research, we would be grateful if you could cite our [publication](https://www.sciencedirect.com/science/article/pii/S0010465518300328).

[Julia]: http://julialang.org
[qojulia]: https://github.com/qojulia
[Quantum Optics Toolbox]: http://qo.phy.auckland.ac.nz/toolbox
[QuTiP]: http://qutip.org

[travis-url]: https://travis-ci.org/qojulia/QuantumOptics.jl
[travis-img]: https://api.travis-ci.org/qojulia/QuantumOptics.jl.png?branch=master

[appveyor-url]: https://ci.appveyor.com/project/qojulia/quantumoptics-jl/branch/master
[appveyor-img]: https://ci.appveyor.com/api/projects/status/t83f2bqfpumn6d96/branch/master?svg=true

[coveralls-url]: https://coveralls.io/github/qojulia/QuantumOptics.jl?branch=master
[coveralls-img]: https://coveralls.io/repos/github/qojulia/QuantumOptics.jl/badge.svg?branch=master

[codecov-url]: https://codecov.io/gh/qojulia/QuantumOptics.jl
[codecov-img]: https://codecov.io/gh/qojulia/QuantumOptics.jl/branch/master/graph/badge.svg

[pkg-0.6-url]: http://pkg.julialang.org/?pkg=QuantumOptics&ver=0.6
[pkg-0.6-img]: http://pkg.julialang.org/badges/QuantumOptics_0.6.svg

[gitter-url]: https://gitter.im/QuantumOptics-jl/Lobby
[gitter-img]: https://img.shields.io/gitter/room/nwjs/nw.js.svg

[docs-url]: https://qojulia.org/documentation/
[docs-img]: https://img.shields.io/badge/docs-stable-blue.svg
